/*  Anything Goos - plug-in for LightWave
Copyright (C) 2009 Eric Winemiller

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.

http://digitalcarversguild.com/
email: ewinemiller @ digitalcarversguild.com (remove space)
*/
#ifndef __MathHelper__
#define __MathHelper__
  
#if CP_PRAGMA_ONCE
#pragma once
#endif

#define FPOSINF 1e20f
#define DPOSINF 1e308

extern float dot( LWFVector a, LWFVector b );
extern void cross( LWFVector a, LWFVector b, LWFVector c );
extern float fsqr(float val);
extern double dsqr(double val);
extern float vsqr(LWFVector a, LWFVector b);
extern double vdfsqr(LWDVector a, LWFVector b);
extern double vddsqr(LWDVector a, LWDVector b);
extern void normalize( LWFVector v );


#ifdef _PPC_

#define M_PI       3.14159265358979323846
#define M_PI_2     1.57079632679489661923

#endif

#endif
